
<?php
/**
 * 301跳转
 * 
 * @package 301重定向
 * @author 大宝
 * @version 1.0.0
 * @link https://dabao.im
 */
class Redirect301_Plugin implements Typecho_Plugin_Interface
{
    /**
     * 激活插件方法,如果激活失败,直接抛出异常
     * 
     * @access public
     * @return void
     * @throws Typecho_Plugin_Exception
     */
    public static function activate()
    {
        Typecho_Plugin::factory('Widget_Archive')->header = array('Redirect301_Plugin', 'header');
    }
    
    /**
     * 禁用插件方法,如果禁用失败,直接抛出异常
     * 
     * @static
     * @access public
     * @return void
     * @throws Typecho_Plugin_Exception
     */
    public static function deactivate(){}
    
    /**
     * 获取插件配置面板
     * 
     * @access public
     * @param Typecho_Widget_Helper_Form $form 配置面板
     * @return void
     */
    public static function config(Typecho_Widget_Helper_Form $form){
          /** 分类名称 */
        $url=Helper::options()->siteUrl;
        $name = new Typecho_Widget_Helper_Form_Element_Text('url', NULL, $url, _t('需要转向的 目标域名 地址，以http://或https://开头，结尾必须要有斜杠“/”结束，例：'.$url.''));
        $form->addInput($name);
    }
    
    /**
     * 个人用户的配置面板
     * 
     * @access public
     * @param Typecho_Widget_Helper_Form $form
     * @return void
     */
    public static function personalConfig(Typecho_Widget_Helper_Form $form){}
    
    /**
     * 插件实现方法
     * 
     * @access public
     * @return void
     */
    public static function header()
    {	
    	$Dabao_im['HOST']=Typecho_Widget::widget('Widget_Options')->plugin('Redirect301')->url;//需要转向的 目标域名 地址，以http://或https://开头，结尾必须要有斜杠“/”结束，例：http://dabao.im/ 
        $http_type = ((isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on') || (isset($_SERVER['HTTP_X_FORWARDED_PROTO']) && $_SERVER['HTTP_X_FORWARDED_PROTO'] == 'https')) ? 'https://' : 'http://';  
        $Dabao_im['URL'] =$http_type. $_SERVER['HTTP_HOST'] . @$_SERVER['REQUEST_URI'];//完整的URL地址

		if(stristr ($Dabao_im['URL'],$Dabao_im['HOST']) == null){
			Header( "HTTP/1.1 301 Moved Permanently"); 
			Header( "Location:".str_replace ($http_type. $_SERVER['HTTP_HOST']. "/",$Dabao_im['HOST'],$Dabao_im['URL']));	
			exit;	
		}
    }
}
